=== modified file 'drizzled/definitions.h'
--- drizzled/definitions.h	2009-04-26 15:49:11 +0000
+++ drizzled/definitions.h	2009-05-06 06:34:21 +0000
@@ -135,15 +135,6 @@
 */
 #define OPTIMIZE_I_S_TABLE     OPEN_TABLE_ONLY*2
 
-#define SC_INFO_LENGTH 4		/* Form format constant */
-#define TE_INFO_LENGTH 3
-
-#define FRM_VER 6
-#define FRM_VER_TRUE_VARCHAR (FRM_VER+4) /* 10 */
-#define DRIZZLE_VERSION_TABLESPACE_IN_FRM_CGE 50120
-#define DRIZZLE_VERSION_TABLESPACE_IN_FRM 50205
-#define DRIZZLE_VERSION_TABLESPACE_IN_FRM_STR "50205"
-
 /*
   Minimum length pattern before Turbo Boyer-Moore is used
   for SELECT "text" LIKE "%pattern%", excluding the two
@@ -317,10 +308,6 @@
 /* Used to check GROUP BY list in the MODE_ONLY_FULL_GROUP_BY mode */
 #define UNDEF_POS (-1)
 
-/* BINLOG_DUMP options */
-
-#define BINLOG_DUMP_NON_BLOCK   1
-
 /* sql_show.cc:show_log_files() */
 #define SHOW_LOG_STATUS_FREE "FREE"
 #define SHOW_LOG_STATUS_INUSE "IN USE"
@@ -458,16 +445,6 @@
 typedef uint64_t query_id_t;
 typedef void *range_seq_t;
 
-
-/**
-   The maximum is defined as (ULONG_MAX/1000) with 4 bytes uint32_t
-*/
-static const uint32_t SLAVE_MAX_HEARTBEAT_PERIOD= 4294967;
-
-#define SLAVE_NET_TIMEOUT  3600
-
-#define MAX_SLAVE_ERROR    2000
-
 /* masks for start/stop operations on io and sql slave threads */
 #define SLAVE_IO  1
 #define SLAVE_SQL 2
@@ -526,7 +503,6 @@
 #define HA_RENAME_TABLE               (36)
 #define HA_ALTER_STORAGE_ENGINE       (37)
 #define HA_RECREATE                   (38)
-#define HA_ALTER_STORED_VCOL          (39)
 /* Remember to increase HA_MAX_ALTER_FLAGS when adding more flags! */
 
 /* Return values for check_if_supported_alter */
@@ -597,21 +573,6 @@
 #define HA_HAS_RECORDS	       (INT64_C(1) << 32) /* records() gives exact count*/
 #define HA_MRR_CANT_SORT       (INT64_C(1) << 34)
 
-/*
-  Engine is capable of row-format and statement-format logging,
-  respectively
-*/
-#define HA_BINLOG_ROW_CAPABLE  (INT64_C(1) << 35)
-#define HA_BINLOG_STMT_CAPABLE (INT64_C(1) << 36)
-
-#define HA_ONLINE_ALTER        (INT64_C(1) << 37)
-
-/*
-  Set of all binlog flags. Currently only contain the capabilities
-  flags.
- */
-#define HA_BINLOG_FLAGS (HA_BINLOG_ROW_CAPABLE | HA_BINLOG_STMT_CAPABLE)
-
 /* bits in index_flags(index_number) for what you can do with index */
 #define HA_READ_NEXT            1       /* TODO really use this flag */
 #define HA_READ_PREV            2       /* supports ::index_prev */
@@ -673,12 +634,6 @@
 #define HA_OPTION_NO_DELAY_KEY_WRITE (1L << 18)
 #define HA_MAX_REC_LENGTH	65535
 
-/* Table caching type */
-#define HA_CACHE_TBL_NONTRANSACT 0
-#define HA_CACHE_TBL_NOCACHE     1
-#define HA_CACHE_TBL_ASKTRANSACT 2
-#define HA_CACHE_TBL_TRANSACT    4
-
 /* Options of START TRANSACTION statement (and later of SET TRANSACTION stmt) */
 #define DRIZZLE_START_TRANS_OPT_WITH_CONS_SNAPSHOT 1
 
@@ -696,24 +651,6 @@
                           COLUMN_FORMAT_TYPE_FIXED=     1,
                           COLUMN_FORMAT_TYPE_DYNAMIC=   2 };
 
-enum enum_binlog_func {
-  BFN_RESET_LOGS=        1,
-  BFN_RESET_SLAVE=       2,
-  BFN_BINLOG_WAIT=       3,
-  BFN_BINLOG_END=        4,
-  BFN_BINLOG_PURGE_FILE= 5
-};
-
-enum enum_binlog_command {
-  LOGCOM_CREATE_TABLE,
-  LOGCOM_ALTER_TABLE,
-  LOGCOM_RENAME_TABLE,
-  LOGCOM_DROP_TABLE,
-  LOGCOM_CREATE_DB,
-  LOGCOM_ALTER_DB,
-  LOGCOM_DROP_DB
-};
-
 /* struct to hold information about the table that should be created */
 
 /* Bits in used_fields */
@@ -744,12 +681,6 @@
 #define MAXGTRIDSIZE 64
 #define MAXBQUALSIZE 64
 
-#define COMPATIBLE_DATA_YES 0
-#define COMPATIBLE_DATA_NO  1
-
-#define UNDEF_NODEGROUP 65535
-#define NOT_A_PARTITION_ID ((uint32_t)-1)
-
 enum ha_choice { HA_CHOICE_UNDEF, HA_CHOICE_NO, HA_CHOICE_YES };
 
 /*
@@ -919,34 +850,6 @@
 #define MY_COLL_CMP_CONV              7
 
 
-/*
-  This enum is used to report information about monotonicity of function
-  represented by Item* tree.
-  Monotonicity is defined only for Item* trees that represent table
-  partitioning expressions (i.e. have no subselects/user vars/PS parameters
-  etc etc). An Item* tree is assumed to have the same monotonicity properties
-  as its correspoinding function F:
-
-  [signed] int64_t F(field1, field2, ...) {
-    put values of field_i into table record buffer;
-    return item->val_int();
-  }
-
-  NOTE
-  At the moment function monotonicity is not well defined (and so may be
-  incorrect) for Item trees with parameters/return types that are different
-  from INT_RESULT, may be NULL, or are unsigned.
-  It will be possible to address this issue once the related partitioning bugs
-  (BUG#16002, BUG#15447, BUG#13436) are fixed.
-*/
-
-typedef enum monotonicity_info
-{
-   NON_MONOTONIC,              /* none of the below holds */
-   MONOTONIC_INCREASING,       /* F() is unary and (x < y) => (F(x) <= F(y)) */
-   MONOTONIC_STRICT_INCREASING /* F() is unary and (x < y) => (F(x) <  F(y)) */
-} enum_monotonicity_info;
-
 enum tmp_table_type
 {
   NO_TMP_TABLE, NON_TRANSACTIONAL_TMP_TABLE, TRANSACTIONAL_TMP_TABLE,
@@ -1030,9 +933,6 @@
 enum enum_enable_or_disable { LEAVE_AS_IS, ENABLE, DISABLE };
 enum enum_delay_key_write { DELAY_KEY_WRITE_NONE, DELAY_KEY_WRITE_ON,
                             DELAY_KEY_WRITE_ALL };
-enum enum_slave_exec_mode { SLAVE_EXEC_MODE_STRICT,
-                            SLAVE_EXEC_MODE_IDEMPOTENT,
-                            SLAVE_EXEC_MODE_LAST_BIT};
 enum enum_mark_columns
 { MARK_COLUMNS_NONE, MARK_COLUMNS_READ, MARK_COLUMNS_WRITE};
 

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2009-04-28 07:29:32 +0000
+++ drizzled/drizzled.cc	2009-05-06 03:58:07 +0000
@@ -2213,11 +2213,6 @@
       "DEFAULT, BACKUP, FORCE or QUICK."),
    (char**) &myisam_recover_options_str, (char**) &myisam_recover_options_str, 0,
    GET_STR, OPT_ARG, 0, 0, 0, 0, 0, 0},
-  {"old-alter-table", OPT_OLD_ALTER_TABLE,
-   N_("Use old, non-optimized alter table."),
-   (char**) &global_system_variables.old_alter_table,
-   (char**) &max_system_variables.old_alter_table, 0, GET_BOOL, NO_ARG,
-   0, 0, 0, 0, 0, 0},
   {"pid-file", OPT_PID_FILE,
    N_("Pid file used by safe_mysqld."),
    (char**) &pidfile_name_ptr, (char**) &pidfile_name_ptr, 0, GET_STR,

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2009-05-04 23:54:28 +0000
+++ drizzled/field.cc	2009-05-06 00:23:47 +0000
@@ -1929,14 +1929,14 @@
   }
 }
 
-bool Field::isRead() 
+bool Field::isReadSet() 
 { 
-  return table->read_set->test(field_index); 
+  return table->isReadSet(field_index); 
 }
 
 
-bool Field::isWrite()
+bool Field::isWriteSet()
 { 
-  return table->write_set->test(field_index); 
+  return table->isWriteSet(field_index); 
 }
 

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2009-05-04 23:54:28 +0000
+++ drizzled/field.h	2009-05-05 16:57:59 +0000
@@ -519,8 +519,8 @@
   friend class Item_sum_max;
   friend class Item_func_group_concat;
 
-  bool isRead();
-  bool isWrite();
+  bool isReadSet();
+  bool isWriteSet();
 
 private:
   /*

=== modified file 'drizzled/field/blob.cc'
--- drizzled/field/blob.cc	2009-04-28 21:46:57 +0000
+++ drizzled/field/blob.cc	2009-05-06 00:23:47 +0000
@@ -605,7 +605,7 @@
   uint32_t const master_packlength=
     param_data > 0 ? param_data & 0xFF : packlength;
   uint32_t const length= get_length(from, master_packlength, low_byte_first);
-  table->write_set->set(field_index);
+  table->setWriteSet(field_index);
   store(reinterpret_cast<const char*>(from) + master_packlength,
         length, field_charset);
   return(from + master_packlength + length);
@@ -674,14 +674,3 @@
     return 0;
   }
 }
-
-bool Field_blob::in_read_set()
-{
-  return (table->read_set->test(field_index));
-}
-
-
-bool Field_blob::in_write_set()
-{
-  return (table->write_set->test(field_index));
-}

=== modified file 'drizzled/field/blob.h'
--- drizzled/field/blob.h	2009-04-28 21:46:57 +0000
+++ drizzled/field/blob.h	2009-05-05 22:21:11 +0000
@@ -193,8 +193,7 @@
   { return charset() == &my_charset_bin ? false : true; }
   uint32_t max_display_length();
   uint32_t is_equal(Create_field *new_field);
-  bool in_read_set();
-  bool in_write_set();
+
 private:
   int do_save_field_metadata(unsigned char *first_byte);
 };

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2009-04-28 00:17:10 +0000
+++ drizzled/filesort.cc	2009-05-06 00:23:47 +0000
@@ -1455,7 +1455,6 @@
   uint32_t length= 0;
   uint32_t fields= 0;
   uint32_t null_fields= 0;
-  bitset<MAX_FIELDS> *read_set= (*ptabfield)->table->read_set;
 
   /*
     If there is a reference to a field in the query add it
@@ -1470,7 +1469,7 @@
 
   for (pfield= ptabfield; (field= *pfield) ; pfield++)
   {
-    if (!read_set->test(field->field_index))
+    if (!(field->isReadSet()))
       continue;
     if (field->flags & BLOB_FLAG)
       return 0;
@@ -1493,7 +1492,7 @@
   null_fields= 0;
   for (pfield= ptabfield; (field= *pfield) ; pfield++)
   {
-    if (!read_set->test(field->field_index))
+    if (!(field->isReadSet()))
       continue;
     addonf->field= field;
     addonf->offset= length;

=== modified file 'drizzled/function/time/to_days.cc'
--- drizzled/function/time/to_days.cc	2009-02-14 19:02:06 +0000
+++ drizzled/function/time/to_days.cc	2009-05-06 06:19:18 +0000
@@ -126,31 +126,6 @@
   return julian_day_number;
 }
 
-/*
-  Get information about this Item tree monotonicity
-
-  SYNOPSIS
-    Item_func_to_days::get_monotonicity_info()
-
-  DESCRIPTION
-  Get information about monotonicity of the function represented by this item
-  tree.
-
-  RETURN
-    See enum_monotonicity_info.
-*/
-enum_monotonicity_info Item_func_to_days::get_monotonicity_info() const
-{
-  if (args[0]->type() == Item::FIELD_ITEM)
-  {
-    if (args[0]->field_type() == DRIZZLE_TYPE_DATE)
-      return MONOTONIC_STRICT_INCREASING;
-    if (args[0]->field_type() == DRIZZLE_TYPE_DATETIME)
-      return MONOTONIC_INCREASING;
-  }
-  return NON_MONOTONIC;
-}
-
 int64_t Item_func_to_days::val_int_endpoint(bool left_endp, bool *incl_endp)
 {
   assert(fixed);

=== modified file 'drizzled/function/time/to_days.h'
--- drizzled/function/time/to_days.h	2009-02-14 19:02:06 +0000
+++ drizzled/function/time/to_days.h	2009-05-06 06:19:18 +0000
@@ -34,7 +34,6 @@
     max_length=6*MY_CHARSET_BIN_MB_MAXLEN;
     maybe_null=1;
   }
-  enum_monotonicity_info get_monotonicity_info() const;
   int64_t val_int_endpoint(bool left_endp, bool *incl_endp);
   bool check_vcol_func_processor(unsigned char *)
   { return false; }

=== modified file 'drizzled/function/time/year.cc'
--- drizzled/function/time/year.cc	2009-01-30 04:01:12 +0000
+++ drizzled/function/time/year.cc	2009-05-06 06:19:18 +0000
@@ -89,28 +89,6 @@
   return (int64_t) temporal.years();
 }
 
-/* information about this Item tree monotonicity
-
-  SYNOPSIS
-    Item_func_year::get_monotonicity_info()
-
-  DESCRIPTION
-  Get information about monotonicity of the function represented by this item
-  tree.
-
-  RETURN
-    See enum_monotonicity_info.
-*/
-
-enum_monotonicity_info Item_func_year::get_monotonicity_info() const
-{
-  if (args[0]->type() == Item::FIELD_ITEM &&
-      (args[0]->field_type() == DRIZZLE_TYPE_DATE ||
-       args[0]->field_type() == DRIZZLE_TYPE_DATETIME))
-    return MONOTONIC_INCREASING;
-  return NON_MONOTONIC;
-}
-
 int64_t Item_func_year::val_int_endpoint(bool left_endp, bool *incl_endp)
 {
   assert(fixed == 1);

=== modified file 'drizzled/function/time/year.h'
--- drizzled/function/time/year.h	2008-12-16 06:21:46 +0000
+++ drizzled/function/time/year.h	2009-05-06 06:19:18 +0000
@@ -28,7 +28,6 @@
   Item_func_year(Item *a) :Item_int_func(a) {}
   int64_t val_int();
   const char *func_name() const { return "year"; }
-  enum_monotonicity_info get_monotonicity_info() const;
   int64_t val_int_endpoint(bool left_endp, bool *incl_endp);
   void fix_length_and_dec()
   {

=== modified file 'drizzled/handler.cc'
--- drizzled/handler.cc	2009-05-04 21:06:03 +0000
+++ drizzled/handler.cc	2009-05-05 16:41:04 +0000
@@ -1520,8 +1520,7 @@
   int error;
 
   (void) extra(HA_EXTRA_KEYREAD);
-  table->mark_columns_used_by_index_no_reset(table->s->next_number_index,
-                                        table->read_set);
+  table->mark_columns_used_by_index_no_reset(table->s->next_number_index);
   index_init(table->s->next_number_index, 1);
   if (table->s->next_number_keypart == 0)
   {						// Autoincrement at key-start
@@ -3618,20 +3617,6 @@
   return 0;
 }
 
-
-
-/**
-  @details
-  use_hidden_primary_key() is called in case of an update/delete when
-  (table_flags() and HA_PRIMARY_KEY_REQUIRED_FOR_DELETE) is defined
-  but we don't have a primary key
-*/
-void handler::use_hidden_primary_key()
-{
-  /* fallback to use all columns in the table to identify row */
-  table->use_all_columns();
-}
-
 void table_case_convert(char * name, uint32_t length)
 {
   if (lower_case_table_names)

=== modified file 'drizzled/handler.h'
--- drizzled/handler.h	2009-05-04 21:06:03 +0000
+++ drizzled/handler.h	2009-05-06 05:44:32 +0000
@@ -593,13 +593,6 @@
   */
   virtual const char **bas_ext() const =0;
 
-  virtual int get_default_no_partitions(HA_CREATE_INFO *) { return 1;}
-  virtual bool get_no_parts(const char *, uint32_t *no_parts)
-  {
-    *no_parts= 0;
-    return 0;
-  }
-
   virtual uint32_t index_flags(uint32_t idx, uint32_t part, bool all_parts) const =0;
 
   virtual int add_index(Table *, KEY *, uint32_t)
@@ -659,10 +652,6 @@
                                      THR_LOCK_DATA **to,
                                      enum thr_lock_type lock_type)=0;
 
-  /** Type of table for caching query */
-  virtual uint8_t table_cache_type() { return HA_CACHE_TBL_NONTRANSACT; }
-
-
  /*
    @retval true   Primary key (if there is one) is clustered
                   key covering all fields
@@ -712,130 +701,6 @@
  virtual Item *idx_cond_push(uint32_t, Item *idx_cond)
  { return idx_cond; }
 
- /*
-    Part of old fast alter table, to be depricated
-  */
- virtual bool
-   check_if_incompatible_data(HA_CREATE_INFO *, uint32_t)
- { return COMPATIBLE_DATA_NO; }
-
- /*
-  * Check if the HA_ALTER_STORED_VCOL bit is set. If it is, then
-  * we will clear all other bits and return true; otherwise 
-  * clear all the bits in the the bitset and return false.
-  *
-  * @param    alter_flags    Bitmap that shows what will be changed
-  */
- virtual bool check_stored_vcol_flag(HA_ALTER_FLAGS *alter_flags)
- {
-   if (alter_flags->test(HA_ALTER_STORED_VCOL))
-   {
-     alter_flags->reset();
-     alter_flags->set(HA_ALTER_STORED_VCOL);
-   }
-   else
-   {
-     alter_flags->reset();
-   }
-   return (alter_flags->any());
- }
-
- /* On-line ALTER Table interface */
-
- /**
-    Check if a storage engine supports a particular alter table on-line
-
-    @param    altered_table     A temporary table show what table is to
-                                change to
-    @param    create_info       Information from the parsing phase about new
-                                table properties.
-    @param    alter_flags       Bitmask that shows what will be changed
-    @param    table_changes     Shows if table layout has changed (for
-                                backwards compatibility with
-                                check_if_incompatible_data
-
-    @retval   HA_ALTER_ERROR                Unexpected error
-    @retval   HA_ALTER_SUPPORTED_WAIT_LOCK  Supported, but requires DDL lock
-    @retval   HA_ALTER_SUPPORTED_NO_LOCK    Supported
-    @retval   HA_ALTER_NOT_SUPPORTED        Not supported
-
-    @note
-      The default implementation is implemented to support fast
-      alter table (storage engines that support some changes by
-      just changing the frm file) without any change in the handler
-      implementation.
- */
- virtual int check_if_supported_alter(Table *, HA_CREATE_INFO *create_info,
-                                      HA_ALTER_FLAGS * alter_flags, uint32_t table_changes)
- {
-   if (this->check_if_incompatible_data(create_info, table_changes)
-       == COMPATIBLE_DATA_NO)
-     return(HA_ALTER_NOT_SUPPORTED);
-   else if (this->check_stored_vcol_flag(alter_flags))
-     return(HA_ALTER_NOT_SUPPORTED);
-   else
-     return(HA_ALTER_SUPPORTED_WAIT_LOCK);
- }
- /**
-   Tell storage engine to prepare for the on-line alter table (pre-alter)
-
-   @param     session               The thread handle
-   @param     altered_table     A temporary table show what table is to
-                                change to
-   @param     alter_info        Storage place for data used during phase1
-                                and phase2
-   @param     alter_flags       Bitmask that shows what will be changed
-
-   @retval   0      OK
-   @retval   error  error code passed from storage engine
- */
- virtual int alter_table_phase1(Session *, Table *, HA_CREATE_INFO *, HA_ALTER_INFO *,
-                                HA_ALTER_FLAGS *)
- {
-   return HA_ERR_UNSUPPORTED;
- }
- /**
-    Tell storage engine to perform the on-line alter table (alter)
-
-    @param    session               The thread handle
-    @param    altered_table     A temporary table show what table is to
-                                change to
-    @param    alter_info        Storage place for data used during phase1
-                                and phase2
-    @param    alter_flags       Bitmask that shows what will be changed
-
-    @retval  0      OK
-    @retval  error  error code passed from storage engine
-
-    @note
-      If check_if_supported_alter returns HA_ALTER_SUPPORTED_WAIT_LOCK
-      this call is to be wrapped with a DDL lock. This is currently NOT
-      supported.
- */
- virtual int alter_table_phase2(Session *, Table *, HA_CREATE_INFO *, HA_ALTER_INFO *,
-                                HA_ALTER_FLAGS *)
- {
-   return HA_ERR_UNSUPPORTED;
- }
- /**
-    Tell storage engine that changed frm file is now on disk and table
-    has been re-opened (post-alter)
-
-    @param    session               The thread handle
-    @param    table             The altered table, re-opened
- */
- virtual int alter_table_phase3(Session *, Table *)
- {
-   return HA_ERR_UNSUPPORTED;
- }
-
-  /**
-    use_hidden_primary_key() is called in case of an update/delete when
-    (table_flags() and HA_PRIMARY_KEY_REQUIRED_FOR_DELETE) is defined
-    but we don't have a primary key
-  */
-  virtual void use_hidden_primary_key();
-
   /**
     Lock table.
 
@@ -864,12 +729,6 @@
   {
     return HA_ERR_WRONG_COMMAND;
   }
-  /*
-    This procedure defines if the storage engine supports virtual columns.
-    Default false means "not supported".
-  */
-  virtual bool check_if_supported_virtual_columns(void)
-  { return false; }
 
 protected:
   /* Service methods for use by storage engines. */

=== modified file 'drizzled/item.h'
--- drizzled/item.h	2009-04-17 02:52:53 +0000
+++ drizzled/item.h	2009-05-06 06:19:18 +0000
@@ -194,14 +194,6 @@
   virtual enum Type type() const =0;
 
   /*
-    Return information about function monotonicity. See comment for
-    enum_monotonicity_info for details. This function can only be called
-    after fix_fields() call.
-  */
-  virtual enum_monotonicity_info get_monotonicity_info() const
-  { return NON_MONOTONIC; }
-
-  /*
     Convert:
       "func_arg $CMP$ const" half-interval
     into:

=== modified file 'drizzled/item/field.h'
--- drizzled/item/field.h	2009-02-07 22:33:25 +0000
+++ drizzled/item/field.h	2009-05-06 06:19:18 +0000
@@ -79,10 +79,6 @@
   enum Item_result result_type () const;
   Item_result cast_to_int_type() const;
   enum_field_types field_type() const;
-  enum_monotonicity_info get_monotonicity_info() const
-  {
-    return MONOTONIC_STRICT_INCREASING;
-  }
   int64_t val_int_endpoint(bool left_endp, bool *incl_endp);
   Field *get_tmp_table_field() { return result_field; }
   Field *tmp_table_field(Table *) { return result_field; }

=== modified file 'drizzled/opt_range.cc'
--- drizzled/opt_range.cc	2009-04-17 14:34:37 +0000
+++ drizzled/opt_range.cc	2009-05-06 00:23:47 +0000
@@ -8064,7 +8064,7 @@
           If the field is used in the current query ensure that it's
           part of 'cur_index'
         */
-        if (table->read_set->test(cur_field->field_index) &&
+        if ((cur_field->isReadSet()) &&
             !cur_field->part_of_key_not_clustered.test(cur_index))
           goto next_index;                  // Field was not part of key
       }
@@ -8237,7 +8237,7 @@
                 (min_max_arg_part && (min_max_arg_part < last_part));
       for (; cur_part != last_part; cur_part++)
       {
-        if (table->read_set->test(cur_part->field->field_index))
+        if (cur_part->field->isReadSet())
           goto next_index;
       }
     }

=== modified file 'drizzled/set_var.cc'
--- drizzled/set_var.cc	2009-04-25 06:33:32 +0000
+++ drizzled/set_var.cc	2009-05-06 03:58:07 +0000
@@ -217,8 +217,6 @@
                                                     &SV::net_retry_count,
                                                     0, fix_net_retry_count);
 /* these two cannot be static */
-sys_var_session_bool sys_old_alter_table(&vars, "old_alter_table",
-                                         &SV::old_alter_table);
 static sys_var_session_bool sys_optimizer_prune_level(&vars, "optimizer_prune_level",
                                                       &SV::optimizer_prune_level);
 static sys_var_session_uint32_t sys_optimizer_search_depth(&vars, "optimizer_search_depth",

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-04-29 07:16:04 +0000
+++ drizzled/show.cc	2009-05-06 06:34:21 +0000
@@ -704,7 +704,6 @@
       if (column_format)
       {
         packet->append(STRING_WITH_LEN(" /*!"));
-        packet->append(STRING_WITH_LEN(DRIZZLE_VERSION_TABLESPACE_IN_FRM_STR));
         packet->append(STRING_WITH_LEN(" COLUMN_FORMAT"));
         if (column_format == COLUMN_FORMAT_TYPE_FIXED)
           packet->append(STRING_WITH_LEN(" FIXED */"));
@@ -2297,7 +2296,7 @@
     int table_open_method= 0, field_indx= 0;
     for (ptr=tables->table->field; (field= *ptr) ; ptr++)
     {
-      if (tables->table->read_set->test(field->field_index))
+      if (field->isReadSet())
         table_open_method|= schema_table->fields_info[field_indx].open_method;
       field_indx++;
     }

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-05-04 18:52:14 +0000
+++ drizzled/sql_base.cc	2009-05-06 00:23:47 +0000
@@ -3894,9 +3894,9 @@
         {
           Table *table= field_to_set->table;
           if (session->mark_used_columns == MARK_COLUMNS_READ)
-            table->read_set->set(field_to_set->field_index);
+            table->setReadSet(field_to_set->field_index);
           else
-            table->write_set->set(field_to_set->field_index);
+            table->setWriteSet(field_to_set->field_index);
         }
       }
   }
@@ -4644,7 +4644,7 @@
       {
         Table *table_1= nj_col_1->table_ref->table;
         /* Mark field_1 used for table cache. */
-        table_1->read_set->set(field_1->field_index);
+        table_1->setReadSet(field_1->field_index);
         table_1->covering_keys&= field_1->part_of_key;
         table_1->merge_keys|= field_1->part_of_key;
       }
@@ -4652,7 +4652,7 @@
       {
         Table *table_2= nj_col_2->table_ref->table;
         /* Mark field_2 used for table cache. */
-        table_2->read_set->set(field_2->field_index);
+        table_2->setReadSet(field_2->field_index);
         table_2->covering_keys&= field_2->part_of_key;
         table_2->merge_keys|= field_2->part_of_key;
       }
@@ -5446,7 +5446,7 @@
       if ((field= field_iterator.field()))
       {
         /* Mark fields as used to allow storage engine to optimze access */
-        field->table->read_set->set(field->field_index);
+        field->table->setReadSet(field->field_index);
         if (table)
         {
           table->covering_keys&= field->part_of_key;

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2009-04-28 00:17:10 +0000
+++ drizzled/sql_parse.cc	2009-05-06 02:03:02 +0000
@@ -304,7 +304,7 @@
   /* Store temp state for processlist */
   session->set_proc_info("cleaning up");
   session->command=COM_SLEEP;
-  session->process_list_info[0]= 0;
+  memset(session->process_list_info, 0, PROCESS_LIST_WIDTH);
   session->query=0;
   session->query_length=0;
 

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2009-04-28 07:29:32 +0000
+++ drizzled/sql_select.cc	2009-05-06 00:23:47 +0000
@@ -6230,12 +6230,11 @@
 {
   uint32_t null_fields,blobs,fields,rec_length;
   Field **f_ptr,*field;
-  bitset<MAX_FIELDS> *read_set= join_tab->table->read_set;
 
   null_fields= blobs= fields= rec_length=0;
   for (f_ptr=join_tab->table->field ; (field= *f_ptr) ; f_ptr++)
   {
-    if (read_set->test(field->field_index))
+    if (field->isReadSet())
     {
       uint32_t flags=field->flags;
       fields++;
@@ -13753,13 +13752,12 @@
   {
     uint32_t null_fields=0, used_fields;
     Field **f_ptr,*field;
-    bitset<MAX_FIELDS> *read_set= tables[i].table->read_set;
     for (f_ptr=tables[i].table->field,used_fields=tables[i].used_fields ;
 	 used_fields ;
 	 f_ptr++)
     {
       field= *f_ptr;
-      if (read_set->test(field->field_index))
+      if (field->isReadSet())
       {
 	used_fields--;
 	length+=field->fill_cache_field(copy);

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-05-04 21:54:14 +0000
+++ drizzled/sql_table.cc	2009-05-06 04:26:21 +0000
@@ -3167,373 +3167,6 @@
 }
 
 
-/**
-   @param       session                Thread
-   @param       table              The original table.
-   @param       alter_info         Alter options, fields and keys for the new
-                                   table.
-   @param       create_info        Create options for the new table.
-   @param       order_num          Number of order list elements.
-   @param[out]  ha_alter_flags  Flags that indicate what will be changed
-   @param[out]  ha_alter_info      Data structures needed for on-line alter
-   @param[out]  table_changes      Information about particular change
-
-   First argument 'table' contains information of the original
-   table, which includes all corresponding parts that the new
-   table has in arguments create_list, key_list and create_info.
-
-   By comparing the changes between the original and new table
-   we can determine how much it has changed after ALTER Table
-   and whether we need to make a copy of the table, or just change
-   the .frm file.
-
-   Mark any changes detected in the ha_alter_flags.
-
-   If there are no data changes, but index changes, 'index_drop_buffer'
-   and/or 'index_add_buffer' are populated with offsets into
-   table->key_info or key_info_buffer respectively for the indexes
-   that need to be dropped and/or (re-)created.
-
-   @retval true  error
-   @retval false success
-*/
-
-static
-bool
-compare_tables(Session *session,
-               Table *table,
-               Alter_info *alter_info,
-               HA_CREATE_INFO *create_info,
-               uint32_t order_num,
-               HA_ALTER_FLAGS *alter_flags,
-               HA_ALTER_INFO *ha_alter_info,
-               uint32_t *table_changes)
-{
-  Field **f_ptr, *field;
-  uint32_t table_changes_local= 0;
-  List_iterator_fast<Create_field> new_field_it(alter_info->create_list);
-  Create_field *new_field;
-  KEY_PART_INFO *key_part;
-  KEY_PART_INFO *end;
-
-  {
-    /*
-      Create a copy of alter_info.
-      To compare the new and old table definitions, we need to "prepare"
-      the new definition - transform it from parser output to a format
-      that describes the final table layout (all column defaults are
-      initialized, duplicate columns are removed). This is done by
-      mysql_prepare_create_table.  Unfortunately,
-      mysql_prepare_create_table performs its transformations
-      "in-place", that is, modifies the argument.  Since we would
-      like to keep compare_tables() idempotent (not altering any
-      of the arguments) we create a copy of alter_info here and
-      pass it to mysql_prepare_create_table, then use the result
-      to evaluate possibility of fast ALTER Table, and then
-      destroy the copy.
-    */
-    Alter_info tmp_alter_info(*alter_info, session->mem_root);
-    session= table->in_use;
-    uint32_t db_options= 0; /* not used */
-    /* Create the prepared information. */
-    if (mysql_prepare_create_table(session, create_info,
-                                   &tmp_alter_info,
-                                   (table->s->tmp_table != NO_TMP_TABLE),
-                                   &db_options,
-                                   table->file,
-                                   &ha_alter_info->key_info_buffer,
-                                   &ha_alter_info->key_count,
-                                   /* select_field_count */ 0))
-      return(true);
-    /* Allocate result buffers. */
-    if (! (ha_alter_info->index_drop_buffer=
-           (uint*) session->alloc(sizeof(uint32_t) * table->s->keys)) ||
-        ! (ha_alter_info->index_add_buffer=
-           (uint*) session->alloc(sizeof(uint32_t) *
-                              tmp_alter_info.key_list.elements)))
-      return(true);
-  }
-  /*
-    First we setup ha_alter_flags based on what was detected
-    by parser
-  */
-  setup_ha_alter_flags(alter_info, alter_flags);
-
-
-  /*
-    Some very basic checks. If number of fields changes, or the
-    handler, we need to run full ALTER Table. In the future
-    new fields can be added and old dropped without copy, but
-    not yet.
-
-    Test also that engine was not given during ALTER Table, or
-    we are force to run regular alter table (copy).
-    E.g. ALTER Table tbl_name ENGINE=MyISAM.
-
-    For the following ones we also want to run regular alter table:
-    ALTER Table tbl_name order_st BY ..
-    ALTER Table tbl_name CONVERT TO CHARACTER SET ..
-
-    At the moment we can't handle altering temporary tables without a copy.
-    We also test if OPTIMIZE Table was given and was mapped to alter table.
-    In that case we always do full copy.
-
-    There was a bug prior to mysql-4.0.25. Number of null fields was
-    calculated incorrectly. As a result frm and data files gets out of
-    sync after fast alter table. There is no way to determine by which
-    mysql version (in 4.0 and 4.1 branches) table was created, thus we
-    disable fast alter table for all tables created by mysql versions
-    prior to 5.0 branch.
-    See BUG#6236.
-  */
-  if (table->s->fields != alter_info->create_list.elements ||
-      table->s->db_type() != create_info->db_type ||
-      table->s->tmp_table ||
-      create_info->used_fields & HA_CREATE_USED_ENGINE ||
-      create_info->used_fields & HA_CREATE_USED_CHARSET ||
-      create_info->used_fields & HA_CREATE_USED_DEFAULT_CHARSET ||
-      create_info->used_fields & HA_CREATE_USED_ROW_FORMAT ||
-      (alter_info->flags & (ALTER_RECREATE | ALTER_FOREIGN_KEY)) ||
-      order_num ||
-      !table->s->mysql_version)
-  {
-    *table_changes= IS_EQUAL_NO;
-    /*
-      Check what has changed and set alter_flags
-    */
-    if (table->s->fields < alter_info->create_list.elements)
-      alter_flags->set(HA_ADD_COLUMN);
-    else if (table->s->fields > alter_info->create_list.elements)
-      alter_flags->set(HA_DROP_COLUMN);
-    if (create_info->db_type != table->s->db_type() ||
-        create_info->used_fields & HA_CREATE_USED_ENGINE)
-      alter_flags->set(HA_ALTER_STORAGE_ENGINE);
-    if (create_info->used_fields & HA_CREATE_USED_CHARSET)
-      alter_flags->set(HA_CHANGE_CHARACTER_SET);
-    if (create_info->used_fields & HA_CREATE_USED_DEFAULT_CHARSET)
-      alter_flags->set(HA_SET_DEFAULT_CHARACTER_SET);
-    if (alter_info->flags & ALTER_RECREATE)
-      alter_flags->set(HA_RECREATE);
-    /* TODO check for ADD/DROP FOREIGN KEY */
-    if (alter_info->flags & ALTER_FOREIGN_KEY)
-      alter_flags->set(HA_ALTER_FOREIGN_KEY);
-  }
-  /*
-    Go through fields and check if the original ones are compatible
-    with new table.
-  */
-  for (f_ptr= table->field, new_field= new_field_it++;
-       (new_field && (field= *f_ptr));
-       f_ptr++, new_field= new_field_it++)
-  {
-    /* Make sure we have at least the default charset in use. */
-    if (!new_field->charset)
-      new_field->charset= create_info->default_table_charset;
-
-    /* Don't pack rows in old tables if the user has requested this. */
-    if (create_info->row_type == ROW_TYPE_DYNAMIC ||
-        (new_field->flags & BLOB_FLAG) ||
-        (new_field->sql_type == DRIZZLE_TYPE_VARCHAR && create_info->row_type != ROW_TYPE_FIXED))
-      create_info->table_options|= HA_OPTION_PACK_RECORD;
-
-    /* Check how fields have been modified */
-    if (alter_info->flags & ALTER_CHANGE_COLUMN)
-    {
-      /* Evaluate changes bitmap and send to check_if_incompatible_data() */
-      if (!(table_changes_local= field->is_equal(new_field)))
-        alter_flags->set(HA_ALTER_COLUMN_TYPE);
-
-      /* Check if field was renamed */
-      field->flags&= ~FIELD_IS_RENAMED;
-      if (my_strcasecmp(system_charset_info,
-                        field->field_name,
-                        new_field->field_name))
-      {
-        field->flags|= FIELD_IS_RENAMED;
-        alter_flags->set(HA_ALTER_COLUMN_NAME);
-      }
-
-      *table_changes&= table_changes_local;
-      if (table_changes_local == IS_EQUAL_PACK_LENGTH)
-        alter_flags->set(HA_ALTER_COLUMN_TYPE);
-
-      /* Check that NULL behavior is same for old and new fields */
-      if ((new_field->flags & NOT_NULL_FLAG) !=
-          (uint32_t) (field->flags & NOT_NULL_FLAG))
-      {
-        *table_changes= IS_EQUAL_NO;
-        alter_flags->set(HA_ALTER_COLUMN_NULLABLE);
-      }
-    }
-
-    /* Clear indexed marker */
-    field->flags&= ~FIELD_IN_ADD_INDEX;
-  }
-
-  /*
-    Go through keys and check if the original ones are compatible
-    with new table.
-  */
-  KEY *table_key;
-  KEY *table_key_end= table->key_info + table->s->keys;
-  KEY *new_key;
-  KEY *new_key_end=
-       ha_alter_info->key_info_buffer + ha_alter_info->key_count;
-
-  /*
-    Step through all keys of the old table and search matching new keys.
-  */
-  ha_alter_info->index_drop_count= 0;
-  ha_alter_info->index_add_count= 0;
-  for (table_key= table->key_info; table_key < table_key_end; table_key++)
-  {
-    KEY_PART_INFO *table_part;
-    KEY_PART_INFO *table_part_end= table_key->key_part + table_key->key_parts;
-    KEY_PART_INFO *new_part;
-
-    /* Search a new key with the same name. */
-    for (new_key= ha_alter_info->key_info_buffer;
-         new_key < new_key_end;
-         new_key++)
-    {
-      if (! strcmp(table_key->name, new_key->name))
-        break;
-    }
-    if (new_key >= new_key_end)
-    {
-      /* Key not found. Add the offset of the key to the drop buffer. */
-      ha_alter_info->index_drop_buffer
-           [ha_alter_info->index_drop_count++]=
-           table_key - table->key_info;
-      if (table_key->flags & HA_NOSAME)
-      {
-        /* Unique key. Check for "PRIMARY". */
-        if (is_primary_key(table_key))
-          alter_flags->set(HA_DROP_PK_INDEX);
-        else
-          alter_flags->set(HA_DROP_UNIQUE_INDEX);
-      }
-      else
-        alter_flags->set(HA_DROP_INDEX);
-      *table_changes= IS_EQUAL_NO;
-      continue;
-    }
-
-    /* Check that the key types are compatible between old and new tables. */
-    if ((table_key->algorithm != new_key->algorithm) ||
-        ((table_key->flags & HA_KEYFLAG_MASK) !=
-         (new_key->flags & HA_KEYFLAG_MASK)) ||
-        (table_key->key_parts != new_key->key_parts))
-    {
-      if (table_key->flags & HA_NOSAME)
-      {
-        // Unique key. Check for "PRIMARY".
-        if (is_primary_key(table_key))
-          alter_flags->set(HA_ALTER_PK_INDEX);
-        else
-          alter_flags->set(HA_ALTER_UNIQUE_INDEX);
-      }
-      else
-        alter_flags->set(HA_ALTER_INDEX);
-      goto index_changed;
-    }
-
-    /*
-      Check that the key parts remain compatible between the old and
-      new tables.
-    */
-    for (table_part= table_key->key_part, new_part= new_key->key_part;
-         table_part < table_part_end;
-         table_part++, new_part++)
-    {
-      /*
-        Key definition has changed if we are using a different field or
-	if the used key part length is different. We know that the fields
-        did not change. Comparing field numbers is sufficient.
-      */
-      if ((table_part->length != new_part->length) ||
-          (table_part->fieldnr - 1 != new_part->fieldnr))
-      {
-        if (table_key->flags & HA_NOSAME)
-        {
-          /* Unique key. Check for "PRIMARY" */
-          if (is_primary_key(table_key))
-            alter_flags->set(HA_ALTER_PK_INDEX);
-          else
-            alter_flags->set(HA_ALTER_UNIQUE_INDEX);
-        }
-        else
-          alter_flags->set(HA_ALTER_INDEX);
-        goto index_changed;
-      }
-    }
-    continue;
-
-  index_changed:
-    /* Key modified. Add the offset of the key to both buffers. */
-    ha_alter_info->index_drop_buffer
-         [ha_alter_info->index_drop_count++]=
-         table_key - table->key_info;
-    ha_alter_info->index_add_buffer
-         [ha_alter_info->index_add_count++]=
-         new_key - ha_alter_info->key_info_buffer;
-    key_part= new_key->key_part;
-    end= key_part + new_key->key_parts;
-    for(; key_part != end; key_part++)
-    {
-      /* Mark field to be part of new key */
-      if ((field= table->field[key_part->fieldnr]))
-        field->flags|= FIELD_IN_ADD_INDEX;
-    }
-    *table_changes= IS_EQUAL_NO;
-  }
-  /*end of for (; table_key < table_key_end;) */
-
-  /*
-    Step through all keys of the new table and find matching old keys.
-  */
-  for (new_key= ha_alter_info->key_info_buffer;
-       new_key < new_key_end;
-       new_key++)
-  {
-    /* Search an old key with the same name. */
-    for (table_key= table->key_info; table_key < table_key_end; table_key++)
-    {
-      if (! strcmp(table_key->name, new_key->name))
-        break;
-    }
-    if (table_key >= table_key_end)
-    {
-      /* Key not found. Add the offset of the key to the add buffer. */
-      ha_alter_info->index_add_buffer
-           [ha_alter_info->index_add_count++]=
-           new_key - ha_alter_info->key_info_buffer;
-      key_part= new_key->key_part;
-      end= key_part + new_key->key_parts;
-      for(; key_part != end; key_part++)
-      {
-        /* Mark field to be part of new key */
-        if ((field= table->field[key_part->fieldnr]))
-          field->flags|= FIELD_IN_ADD_INDEX;
-      }
-      if (new_key->flags & HA_NOSAME)
-      {
-        /* Unique key. Check for "PRIMARY" */
-        if (is_primary_key(new_key))
-          alter_flags->set(HA_ADD_PK_INDEX);
-        else
-        alter_flags->set(HA_ADD_UNIQUE_INDEX);
-      }
-      else
-        alter_flags->set(HA_ADD_INDEX);
-      *table_changes= IS_EQUAL_NO;
-    }
-  }
-
-  return(false);
-}
-
-
 /*
   Manages enabling/disabling of indexes for ALTER Table
 
@@ -3647,201 +3280,6 @@
   return(error);
 }
 
-/*
-  Create a temporary table that reflects what an alter table operation
-  will accomplish.
-
-  SYNOPSIS
-    create_altered_table()
-      session              Thread handle
-      table            The original table
-      create_info      Information from the parsing phase about new
-                       table properties.
-      alter_info       Lists of fields, keys to be changed, added
-                       or dropped.
-      db_change        Specifies if the table is moved to another database
-  RETURN
-    A temporary table with all changes
-    NULL if error
-  NOTES
-    The temporary table is created without storing it in any storage engine
-    and is opened only to get the table struct and frm file reference.
-*/
-Table *create_altered_table(Session *session,
-                            Table *table,
-                            char *new_db,
-                            HA_CREATE_INFO *create_info,
-                            Alter_info *alter_info,
-                            bool db_change)
-{
-  int error;
-  HA_CREATE_INFO altered_create_info(*create_info);
-  Table *altered_table;
-  char tmp_name[80];
-  char path[FN_REFLEN];
-
-  snprintf(tmp_name, sizeof(tmp_name), "%s-%lx_%"PRIx64,
-           TMP_FILE_PREFIX, (unsigned long)current_pid, session->thread_id);
-  /* Safety fix for InnoDB */
-  if (lower_case_table_names)
-    my_casedn_str(files_charset_info, tmp_name);
-  altered_create_info.options&= ~HA_LEX_CREATE_TMP_TABLE;
-
-  if ((error= create_temporary_table(session, table, new_db, tmp_name,
-                                     &altered_create_info,
-                                     alter_info, db_change)))
-  {
-    return(NULL);
-  };
-
-  build_table_filename(path, sizeof(path), new_db, tmp_name, "",
-                       FN_IS_TMP);
-  altered_table= open_temporary_table(session, path, new_db, tmp_name, 1,
-                                      OTM_ALTER);
-  return(altered_table);
-}
-
-
-/*
-  Perform a fast or on-line alter table
-
-  SYNOPSIS
-    mysql_fast_or_online_alter_table()
-      session              Thread handle
-      table            The original table
-      altered_table    A temporary table showing how we will change table
-      create_info      Information from the parsing phase about new
-                       table properties.
-      alter_info       Storage place for data used during different phases
-      ha_alter_flags   Bitmask that shows what will be changed
-      keys_onoff       Specifies if keys are to be enabled/disabled
-  RETURN
-     0  OK
-    >0  An error occured during the on-line alter table operation
-    -1  Error when re-opening table
-  NOTES
-    If mysql_alter_table does not need to copy the table, it is
-    either a fast alter table where the storage engine does not
-    need to know about the change, only the frm will change,
-    or the storage engine supports performing the alter table
-    operation directly, on-line without mysql having to copy
-    the table.
-*/
-int mysql_fast_or_online_alter_table(Session *session,
-                                     Table *table,
-                                     Table *altered_table,
-                                     HA_CREATE_INFO *create_info,
-                                     HA_ALTER_INFO *alter_info,
-                                     HA_ALTER_FLAGS *ha_alter_flags,
-                                     enum enum_enable_or_disable keys_onoff)
-{
-  int error= 0;
-  bool online= (table->file->ha_table_flags() & HA_ONLINE_ALTER)?true:false;
-  Table *t_table;
-
-  if (online)
-  {
-   /*
-      Tell the handler to prepare for the online alter
-    */
-    if ((error= table->file->alter_table_phase1(session,
-                                                altered_table,
-                                                create_info,
-                                                alter_info,
-                                                ha_alter_flags)))
-    {
-      goto err;
-    }
-
-    /*
-       Tell the storage engine to perform the online alter table
-       TODO:
-       if check_if_supported_alter() returned HA_ALTER_SUPPORTED_WAIT_LOCK
-       we need to wrap the next call with a DDL lock.
-     */
-    if ((error= table->file->alter_table_phase2(session,
-                                                altered_table,
-                                                create_info,
-                                                alter_info,
-                                                ha_alter_flags)))
-    {
-      goto err;
-    }
-  }
-  /*
-    The final .frm file is already created as a temporary file
-    and will be renamed to the original table name.
-  */
-  pthread_mutex_lock(&LOCK_open);
-  wait_while_table_is_used(session, table, HA_EXTRA_FORCE_REOPEN);
-  alter_table_manage_keys(table, table->file->indexes_are_disabled(),
-                          keys_onoff);
-  close_data_files_and_morph_locks(session,
-                                   table->pos_in_table_list->db,
-                                   table->pos_in_table_list->table_name);
-  if (mysql_rename_table(NULL,
-			 altered_table->s->db.str,
-                         altered_table->s->table_name.str,
-			 table->s->db.str,
-                         table->s->table_name.str, FN_FROM_IS_TMP))
-  {
-    error= 1;
-    pthread_mutex_unlock(&LOCK_open);
-    goto err;
-  }
-  broadcast_refresh();
-  pthread_mutex_unlock(&LOCK_open);
-
-  /*
-    The ALTER Table is always in its own transaction.
-    Commit must not be called while LOCK_open is locked. It could call
-    wait_if_global_read_lock(), which could create a deadlock if called
-    with LOCK_open.
-  */
-  error= ha_autocommit_or_rollback(session, 0);
-
-  if (ha_commit(session))
-    error=1;
-  if (error)
-    goto err;
-  if (online)
-  {
-    pthread_mutex_lock(&LOCK_open);
-    if (reopen_table(table))
-    {
-      error= -1;
-      goto err;
-    }
-    pthread_mutex_unlock(&LOCK_open);
-    t_table= table;
-
-   /*
-      Tell the handler that the changed frm is on disk and table
-      has been re-opened
-   */
-    if ((error= t_table->file->alter_table_phase3(session, t_table)))
-    {
-      goto err;
-    }
-
-    /*
-      We are going to reopen table down on the road, so we have to restore
-      state of the Table object which we used for obtaining of handler
-      object to make it suitable for reopening.
-    */
-    assert(t_table == table);
-    table->open_placeholder= 1;
-    pthread_mutex_lock(&LOCK_open);
-    close_handle_and_leave_table_as_lock(table);
-    pthread_mutex_unlock(&LOCK_open);
-  }
-
- err:
-  if (error)
-    return(error);
-  return 0;
-}
-
 
 /**
   Prepare column and key definitions for CREATE TABLE in ALTER Table.
@@ -4571,135 +4009,7 @@
 
   set_table_default_charset(session, create_info, db);
 
-  if (session->variables.old_alter_table
-      || (table->s->db_type() != create_info->db_type)
-     )
-  {
-    if (alter_info->build_method == HA_BUILD_ONLINE)
-    {
-      my_error(ER_NOT_SUPPORTED_YET, MYF(0), session->query);
-      goto err;
-    }
-    alter_info->build_method= HA_BUILD_OFFLINE;
-  }
-
-  if (alter_info->build_method != HA_BUILD_OFFLINE)
-  {
-    Table *altered_table= 0;
-    HA_ALTER_INFO ha_alter_info;
-    HA_ALTER_FLAGS ha_alter_flags;
-    uint32_t table_changes= IS_EQUAL_YES;
-    bool need_copy_table= true;
-    /* Check how much the tables differ. */
-    if (compare_tables(session, table, alter_info,
-                       create_info, order_num,
-                       &ha_alter_flags,
-                       &ha_alter_info,
-                       &table_changes))
-    {
-      return(true);
-    }
-
-    /*
-      Check if storage engine supports altering the table
-      on-line.
-    */
-
-
-    /*
-      If table is not renamed, changed database and
-      some change was detected then check if engine
-      can do the change on-line
-    */
-    if (new_name == table_name && new_db == db &&
-        ha_alter_flags.any())
-    {
-      Alter_info tmp_alter_info(*alter_info, session->mem_root);
-
-      /*
-        If no table rename,
-        check if table can be altered on-line
-      */
-      if (!(altered_table= create_altered_table(session,
-                                                table,
-                                                new_db,
-                                                create_info,
-                                                &tmp_alter_info,
-                                                !strcmp(db, new_db))))
-        goto err;
-
-      switch (table->file->check_if_supported_alter(altered_table,
-                                                    create_info,
-                                                    &ha_alter_flags,
-                                                    table_changes)) {
-      case HA_ALTER_SUPPORTED_WAIT_LOCK:
-      case HA_ALTER_SUPPORTED_NO_LOCK:
-        /*
-          @todo: Currently we always acquire an exclusive name
-          lock on the table metadata when performing fast or online
-          ALTER Table. In future we may consider this unnecessary,
-          and narrow the scope of the exclusive name lock to only
-          cover manipulation with .frms. Storage engine API
-          call check_if_supported_alter has provision for this
-          already now.
-        */
-        need_copy_table= false;
-        break;
-      case HA_ALTER_NOT_SUPPORTED:
-        if (alter_info->build_method == HA_BUILD_ONLINE)
-        {
-          my_error(ER_NOT_SUPPORTED_YET, MYF(0), session->query);
-          close_temporary_table(session, altered_table, 1, 1);
-          goto err;
-        }
-        need_copy_table= true;
-        break;
-      case HA_ALTER_ERROR:
-      default:
-        close_temporary_table(session, altered_table, 1, 1);
-        goto err;
-      }
-
-    }
-    /* TODO need to check if changes can be handled as fast ALTER Table */
-    if (!altered_table)
-      need_copy_table= true;
-
-    if (!need_copy_table)
-    {
-      error= mysql_fast_or_online_alter_table(session,
-                                              table,
-                                              altered_table,
-                                              create_info,
-                                              &ha_alter_info,
-                                              &ha_alter_flags,
-                                              alter_info->keys_onoff);
-      if (session->lock)
-      {
-        mysql_unlock_tables(session, session->lock);
-        session->lock=0;
-      }
-      close_temporary_table(session, altered_table, 1, 1);
-
-      if (error)
-      {
-        switch (error) {
-        case(-1):
-          goto err_with_placeholders;
-        default:
-          goto err;
-        }
-      }
-      else
-      {
-        pthread_mutex_lock(&LOCK_open);
-        goto end_online;
-      }
-    }
-
-    if (altered_table)
-      close_temporary_table(session, altered_table, 1, 1);
-  }
+  alter_info->build_method= HA_BUILD_OFFLINE;
 
   snprintf(tmp_name, sizeof(tmp_name), "%s-%lx_%"PRIx64, TMP_FILE_PREFIX,
            (unsigned long)current_pid, session->thread_id);
@@ -4874,7 +4184,6 @@
 
   quick_rm_table(old_db_type, db, old_name, FN_IS_TMP);
 
-end_online:
   if (session->locked_tables && new_name == table_name && new_db == db)
   {
     session->in_lock_tables= 1;

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-05-04 22:41:24 +0000
+++ drizzled/table.cc	2009-05-05 16:41:04 +0000
@@ -2632,7 +2632,7 @@
   if ((file->ha_table_flags() & HA_PRIMARY_KEY_IN_READ_INDEX) &&
       s->primary_key < MAX_KEY)
   {
-    mark_columns_used_by_index_no_reset(s->primary_key, read_set);
+    mark_columns_used_by_index_no_reset(s->primary_key);
   }
   return;
 }
@@ -2684,6 +2684,11 @@
   mark columns used by key, but don't reset other fields
 */
 
+void Table::mark_columns_used_by_index_no_reset(uint32_t index)
+{
+    mark_columns_used_by_index_no_reset(index, read_set);
+}
+
 void Table::mark_columns_used_by_index_no_reset(uint32_t index,
                                                 bitset<MAX_FIELDS> *bitmap)
 {
@@ -2713,7 +2718,7 @@
   read_set->set(found_next_number_field->field_index);
   write_set->set(found_next_number_field->field_index);
   if (s->next_number_keypart)
-    mark_columns_used_by_index_no_reset(s->next_number_index, read_set);
+    mark_columns_used_by_index_no_reset(s->next_number_index);
 }
 
 
@@ -2737,6 +2742,23 @@
 
 void Table::mark_columns_needed_for_delete()
 {
+  /*
+    If the handler has no cursor capabilites, or we have row-based
+    replication active for the current statement, we have to read
+    either the primary key, the hidden primary key or all columns to
+    be able to do an delete
+
+  */
+  if (s->primary_key == MAX_KEY)
+  {
+    /* fallback to use all columns in the table to identify row */
+    use_all_columns();
+    return;
+  }
+  else
+    mark_columns_used_by_index_no_reset(s->primary_key);
+
+  /* If we the engine wants all predicates we mark all keys */
   if (file->ha_table_flags() & HA_REQUIRES_KEY_COLUMNS_FOR_DELETE)
   {
     Field **reg_field;
@@ -2746,19 +2768,6 @@
         read_set->set((*reg_field)->field_index);
     }
   }
-
-  {
-    /*
-      If the handler has no cursor capabilites, or we have row-based
-      replication active for the current statement, we have to read
-      either the primary key, the hidden primary key or all columns to
-      be able to do an delete
-    */
-    if (s->primary_key == MAX_KEY)
-      file->use_hidden_primary_key();
-    else
-      mark_columns_used_by_index_no_reset(s->primary_key, read_set);
-  }
 }
 
 
@@ -2782,6 +2791,21 @@
 
 void Table::mark_columns_needed_for_update()
 {
+  /*
+    If the handler has no cursor capabilites, or we have row-based
+    logging active for the current statement, we have to read either
+    the primary key, the hidden primary key or all columns to be
+    able to do an update
+  */
+  if (s->primary_key == MAX_KEY)
+  {
+    /* fallback to use all columns in the table to identify row */
+    use_all_columns();
+    return;
+  }
+  else
+    mark_columns_used_by_index_no_reset(s->primary_key);
+
   if (file->ha_table_flags() & HA_REQUIRES_KEY_COLUMNS_FOR_DELETE)
   {
     /* Mark all used key columns for read */
@@ -2794,19 +2818,6 @@
     }
   }
 
-  {
-    /*
-      If the handler has no cursor capabilites, or we have row-based
-      logging active for the current statement, we have to read either
-      the primary key, the hidden primary key or all columns to be
-      able to do an update
-    */
-    if (s->primary_key == MAX_KEY)
-      file->use_hidden_primary_key();
-    else
-      mark_columns_used_by_index_no_reset(s->primary_key, read_set);
-  }
-  return;
 }
 
 

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2009-05-04 21:06:03 +0000
+++ drizzled/table.h	2009-05-06 00:23:47 +0000
@@ -70,8 +70,10 @@
                              int error, bool ignore_last_dupp_key_error);
 
 class Table {
-
 public:
+  std::bitset<MAX_FIELDS> def_read_set, def_write_set, tmp_set; /* containers */
+  std::bitset<MAX_FIELDS> *read_set, *write_set;                /* Active column sets */
+
   TableShare	*s;
   Table() {}                               /* Remove gcc warning */
 
@@ -162,8 +164,7 @@
   order_st *group;
   const char	*alias;            	  /* alias or table name */
   unsigned char		*null_flags;
-  std::bitset<MAX_FIELDS> def_read_set, def_write_set, tmp_set; /* containers */
-  std::bitset<MAX_FIELDS> *read_set, *write_set;                /* Active column sets */
+
   /*
    The ID of the query that opened and is using this table. Has different
    meanings depending on the table type.
@@ -289,6 +290,7 @@
   void clear_column_bitmaps(void);
   void prepare_for_position(void);
   void mark_columns_used_by_index_no_reset(uint32_t index, std::bitset<MAX_FIELDS> *map);
+  void mark_columns_used_by_index_no_reset(uint32_t index);
   void mark_columns_used_by_index(uint32_t index);
   void restore_column_maps_after_mark_index();
   void mark_auto_increment_column(void);
@@ -322,6 +324,27 @@
     write_set= &def_write_set;
   }
 
+  /* Both of the below should go away once we can move this bit to the field objects */
+  inline bool isReadSet(uint32_t index)
+  {
+    return read_set->test(index);
+  }
+
+  inline void setReadSet(uint32_t index)
+  {
+    read_set->set(index);
+  }
+
+  inline bool isWriteSet(uint32_t index)
+  {
+    return write_set->test(index);
+  }
+
+  inline void setWriteSet(uint32_t index)
+  {
+    write_set->set(index);
+  }
+
   /* Is table open or should be treated as such by name-locking? */
   inline bool is_name_opened() { return db_stat || open_placeholder; }
   /*

=== modified file 'drizzled/unireg.h'
--- drizzled/unireg.h	2009-04-26 15:49:11 +0000
+++ drizzled/unireg.h	2009-05-06 06:34:21 +0000
@@ -118,14 +118,6 @@
 */
 #define OPEN_TABLE_ONLY        OPEN_FRM_FILE_ONLY*2
 
-#define SC_INFO_LENGTH 4		/* Form format constant */
-#define TE_INFO_LENGTH 3
-
-
-#define DRIZZLE_VERSION_TABLESPACE_IN_FRM_CGE 50120
-#define DRIZZLE_VERSION_TABLESPACE_IN_FRM 50205
-#define DRIZZLE_VERSION_TABLESPACE_IN_FRM_STR "50205"
-
 /*
   Minimum length pattern before Turbo Boyer-Moore is used
   for SELECT "text" LIKE "%pattern%", excluding the two
@@ -133,14 +125,6 @@
 */
 #define MIN_TURBOBM_PATTERN_LEN 3
 
-/*
-   Defines for binary logging.
-   Do not decrease the value of BIN_LOG_HEADER_SIZE.
-   Do not even increase it before checking code.
-*/
-
-#define BIN_LOG_HEADER_SIZE    4
-
 #define DEFAULT_KEY_CACHE_NAME "default"
 
 #define STORAGE_TYPE_MASK 7

=== modified file 'drizzled/xid.cc'
--- drizzled/xid.cc	2009-03-17 05:47:13 +0000
+++ drizzled/xid.cc	2009-05-05 21:20:32 +0000
@@ -126,8 +126,9 @@
 
 void xid_free_hash(void *ptr)
 {
-  if (!((XID_STATE*)ptr)->in_session)
-    free((unsigned char*)ptr);
+  XID_STATE *state= (XID_STATE *)ptr;
+  if (state->in_session == false)
+    delete state;
 }
 
 bool xid_cache_init()
@@ -160,15 +161,15 @@
   bool res;
   pthread_mutex_lock(&LOCK_xid_cache);
   if (hash_search(&xid_cache, xid->key(), xid->key_length()))
-    res=0;
-  else if (!(xs=(XID_STATE *)malloc(sizeof(*xs))))
-    res=1;
+    res= false;
+  else if ((xs = new XID_STATE) == NULL)
+    res= true;
   else
   {
     xs->xa_state=xa_state;
     xs->xid.set(xid);
     xs->in_session=0;
-    res=my_hash_insert(&xid_cache, (unsigned char*)xs);
+    res= my_hash_insert(&xid_cache, (unsigned char*)xs);
   }
   pthread_mutex_unlock(&LOCK_xid_cache);
   return res;

=== modified file 'plugin/archive/ha_archive.h'
--- plugin/archive/ha_archive.h	2009-05-01 22:50:51 +0000
+++ plugin/archive/ha_archive.h	2009-05-06 05:44:32 +0000
@@ -101,7 +101,6 @@
   uint64_t table_flags() const
   {
     return (HA_NO_TRANSACTIONS | HA_REC_NOT_IN_SEQ |
-            HA_BINLOG_ROW_CAPABLE | HA_BINLOG_STMT_CAPABLE |
             HA_STATS_RECORDS_IS_EXACT |
             HA_HAS_RECORDS |
             HA_FILE_BASED);

=== modified file 'plugin/csv/ha_tina.cc'
--- plugin/csv/ha_tina.cc	2009-04-29 07:16:04 +0000
+++ plugin/csv/ha_tina.cc	2009-05-06 05:44:32 +0000
@@ -588,7 +588,7 @@
   off_t end_offset, curr_offset= current_position;
   int eoln_len;
   int error;
-  bool read_all;
+  bool read_all= false;
 
   free_root(&blobroot, MYF(MY_MARK_BLOCKS_FREE));
 
@@ -601,12 +601,20 @@
                        local_saved_data_file_length, &eoln_len)) == 0)
     return(HA_ERR_END_OF_FILE);
 
-  /* We must read all columns in case a table is opened for update */
-  read_all= !table->write_set->none();
   error= HA_ERR_CRASHED_ON_USAGE;
 
   memset(buf, 0, table->s->null_bytes);
 
+  /* We need to first check to see if this is a write (rewrite this to something sane that knows if we are doing an update) */
+  for (Field **field=table->field ; *field ; field++)
+  {
+    if ((*field)->isWriteSet())
+    {
+      read_all= true;
+      break;
+    }
+  }
+
   for (Field **field=table->field ; *field ; field++)
   {
     char curr_char;
@@ -672,7 +680,7 @@
       }
     }
 
-    if (read_all || table->read_set->test((*field)->field_index))
+    if (read_all || (*field)->isReadSet())
     {
       if ((*field)->store(buffer.ptr(), buffer.length(), buffer.charset(),
                           CHECK_FIELD_WARN))
@@ -1532,11 +1540,6 @@
 }
 
 
-bool ha_tina::check_if_incompatible_data(HA_CREATE_INFO *, uint32_t)
-{
-  return COMPATIBLE_DATA_YES;
-}
-
 drizzle_declare_plugin(csv)
 {
   "CSV",

=== modified file 'plugin/csv/ha_tina.h'
--- plugin/csv/ha_tina.h	2009-04-28 21:46:57 +0000
+++ plugin/csv/ha_tina.h	2009-05-06 05:44:32 +0000
@@ -105,8 +105,7 @@
   const char **bas_ext() const;
   uint64_t table_flags() const
   {
-    return (HA_NO_TRANSACTIONS | HA_REC_NOT_IN_SEQ | HA_NO_AUTO_INCREMENT |
-            HA_BINLOG_ROW_CAPABLE | HA_BINLOG_STMT_CAPABLE);
+    return (HA_NO_TRANSACTIONS | HA_REC_NOT_IN_SEQ | HA_NO_AUTO_INCREMENT);
   }
   uint32_t index_flags(uint32_t, uint32_t, bool) const
   {
@@ -152,8 +151,6 @@
   int info(uint);
   int delete_all_rows(void);
   int create(const char *name, Table *form, HA_CREATE_INFO *create_info);
-  bool check_if_incompatible_data(HA_CREATE_INFO *info,
-                                  uint32_t table_changes);
 
   THR_LOCK_DATA **store_lock(Session *session, THR_LOCK_DATA **to,
       enum thr_lock_type lock_type);

=== modified file 'plugin/heap/ha_heap.cc'
--- plugin/heap/ha_heap.cc	2009-04-29 07:16:04 +0000
+++ plugin/heap/ha_heap.cc	2009-05-06 06:34:21 +0000
@@ -837,18 +837,6 @@
 }
 
 
-bool ha_heap::check_if_incompatible_data(HA_CREATE_INFO *info_in,
-					 uint32_t table_changes)
-{
-  /* Check that auto_increment value was not changed */
-  if ((info_in->used_fields & HA_CREATE_USED_AUTO &&
-       info_in->auto_increment_value != 0) ||
-      table_changes == IS_EQUAL_NO ||
-      table_changes & IS_EQUAL_PACK_LENGTH) // Not implemented yet
-    return COMPATIBLE_DATA_NO;
-  return COMPATIBLE_DATA_YES;
-}
-
 drizzle_declare_plugin(heap)
 {
   "MEMORY",

=== modified file 'plugin/heap/ha_heap.h'
--- plugin/heap/ha_heap.h	2009-04-28 21:46:57 +0000
+++ plugin/heap/ha_heap.h	2009-05-06 06:34:21 +0000
@@ -51,7 +51,6 @@
   uint64_t table_flags() const
   {
     return (HA_FAST_KEY_READ | HA_NO_BLOBS | HA_NULL_IN_KEY |
-            HA_BINLOG_ROW_CAPABLE | HA_BINLOG_STMT_CAPABLE |
             HA_REC_NOT_IN_SEQ | HA_NO_TRANSACTIONS |
             HA_HAS_RECORDS | HA_STATS_RECORDS_IS_EXACT);
   }
@@ -110,7 +109,6 @@
   THR_LOCK_DATA **store_lock(Session *session, THR_LOCK_DATA **to,
                              enum thr_lock_type lock_type);
   int cmp_ref(const unsigned char *ref1, const unsigned char *ref2);
-  bool check_if_incompatible_data(HA_CREATE_INFO *info, uint32_t table_changes);
 private:
   void update_key_stats();
 };

=== modified file 'plugin/innobase/handler/ha_innodb.cc'
--- plugin/innobase/handler/ha_innodb.cc	2009-05-04 23:54:28 +0000
+++ plugin/innobase/handler/ha_innodb.cc	2009-05-06 05:58:40 +0000
@@ -1304,7 +1304,6 @@
 		  HA_CAN_INDEX_BLOBS |
 		  HA_PRIMARY_KEY_REQUIRED_FOR_POSITION |
 		  HA_PRIMARY_KEY_IN_READ_INDEX |
-		  HA_BINLOG_ROW_CAPABLE |
 		  HA_PARTIAL_COLUMN_READ |
 		  HA_TABLE_SCAN_ON_INDEX | 
                   HA_MRR_CANT_SORT),
@@ -1402,203 +1401,6 @@
 	}
 }
 
-/*   BACKGROUND INFO: HOW THE DRIZZLE QUERY CACHE WORKS WITH INNODB
-     ------------------------------------------------------------
-
-1) The use of the query cache for TBL is disabled when there is an
-uncommitted change to TBL.
-
-2) When a change to TBL commits, InnoDB stores the current value of
-its global trx id counter, let us denote it by INV_TRX_ID, to the table object
-in the InnoDB data dictionary, and does only allow such transactions whose
-id <= INV_TRX_ID to use the query cache.
-
-3) When InnoDB does an INSERT/DELETE/UPDATE to a table TBL, or an implicit
-modification because an ON DELETE CASCADE, we invalidate the MySQL query cache
-of TBL immediately.
-
-How this is implemented inside InnoDB:
-
-1) Since every modification always sets an IX type table lock on the InnoDB
-table, it is easy to check if there can be uncommitted modifications for a
-table: just check if there are locks in the lock list of the table.
-
-2) When a transaction inside InnoDB commits, it reads the global trx id
-counter and stores the value INV_TRX_ID to the tables on which it had a lock.
-
-3) If there is an implicit table change from ON DELETE CASCADE or SET NULL,
-InnoDB calls an invalidate method for the MySQL query cache for that table.
-
-How this is implemented inside sql_cache.cc:
-
-1) The query cache for an InnoDB table TBL is invalidated immediately at an
-INSERT/UPDATE/DELETE, just like in the case of MyISAM. No need to delay
-invalidation to the transaction commit.
-
-2) To store or retrieve a value from the query cache of an InnoDB table TBL,
-any query must first ask InnoDB's permission. We must pass the session as a
-parameter because InnoDB will look at the trx id, if any, associated with
-that session.
-
-3) Use of the query cache for InnoDB tables is now allowed also when
-AUTOCOMMIT==0 or we are inside BEGIN ... COMMIT. Thus transactions no longer
-put restrictions on the use of the query cache.
-*/
-
-/**********************************************************************
-The MySQL query cache uses this to check from InnoDB if the query cache at
-the moment is allowed to operate on an InnoDB table. The SQL query must
-be a non-locking SELECT.
-
-The query cache is allowed to operate on certain query only if this function
-returns TRUE for all tables in the query.
-
-If session is not in the autocommit state, this function also starts a new
-transaction for session if there is no active trx yet, and assigns a consistent
-read view to it if there is no read view yet.
-
-Why a deadlock of threads is not possible: the query cache calls this function
-at the start of a SELECT processing. Then the calling thread cannot be
-holding any InnoDB semaphores. The calling thread is holding the
-query cache mutex, and this function will reserver the InnoDB kernel mutex.
-Thus, the 'rank' in sync0sync.h of the MySQL query cache mutex is above
-the InnoDB kernel mutex. */
-static
-my_bool
-innobase_query_caching_of_table_permitted(
-/*======================================*/
-				/* out: TRUE if permitted, FALSE if not;
-				note that the value FALSE does not mean
-				we should invalidate the query cache:
-				invalidation is called explicitly */
-	Session*	session,		/* in: session of the user who is trying to
-				store a result to the query cache or
-				retrieve it */
-	char*	full_name,	/* in: concatenation of database name,
-				the null character '\0', and the table
-				name */
-	uint	full_name_len,	/* in: length of the full name, i.e.
-				len(dbname) + len(tablename) + 1 */
-	uint64_t *)	/* unused for this engine */
-{
-	ibool	is_autocommit;
-	trx_t*	trx;
-	char	norm_name[1000];
-
-	ut_a(full_name_len < 999);
-
-	trx = check_trx_exists(session);
-
-	if (trx->isolation_level == TRX_ISO_SERIALIZABLE) {
-		/* In the SERIALIZABLE mode we add LOCK IN SHARE MODE to every
-		plain SELECT if AUTOCOMMIT is not on. */
-
-		return((my_bool)FALSE);
-	}
-
-	if (trx->has_search_latch) {
-		errmsg_printf(ERRMSG_LVL_ERROR,
-			      "The calling thread is holding the adaptive "
-			      "search, latch though calling "
-			      "innobase_query_caching_of_table_permitted.");
-
-		mutex_enter(&kernel_mutex);
-		trx_print(stderr, trx, 1024);
-		mutex_exit(&kernel_mutex);
-	}
-
-	innobase_release_stat_resources(trx);
-
-	if (!session_test_options(session, OPTION_NOT_AUTOCOMMIT | OPTION_BEGIN)) {
-
-		is_autocommit = TRUE;
-	} else {
-		is_autocommit = FALSE;
-
-	}
-
-	if (is_autocommit && trx->n_mysql_tables_in_use == 0) {
-		/* We are going to retrieve the query result from the query
-		cache. This cannot be a store operation to the query cache
-		because then MySQL would have locks on tables already.
-
-		TODO: if the user has used LOCK TABLES to lock the table,
-		then we open a transaction in the call of row_.. below.
-		That trx can stay open until UNLOCK TABLES. The same problem
-		exists even if we do not use the query cache. MySQL should be
-		modified so that it ALWAYS calls some cleanup function when
-		the processing of a query ends!
-
-		We can imagine we instantaneously serialize this consistent
-		read trx to the current trx id counter. If trx2 would have
-		changed the tables of a query result stored in the cache, and
-		trx2 would have already committed, making the result obsolete,
-		then trx2 would have already invalidated the cache. Thus we
-		can trust the result in the cache is ok for this query. */
-
-		return((my_bool)TRUE);
-	}
-
-	/* Normalize the table name to InnoDB format */
-
-	memcpy(norm_name, full_name, full_name_len);
-
-	norm_name[strlen(norm_name)] = '/'; /* InnoDB uses '/' as the
-					    separator between db and table */
-	norm_name[full_name_len] = '\0';
-#ifdef __WIN__
-	innobase_casedn_str(norm_name);
-#endif
-	/* The call of row_search_.. will start a new transaction if it is
-	not yet started */
-
-	if (trx->active_trans == 0) {
-
-		innobase_register_trx_and_stmt(innodb_engine_ptr, session);
-		trx->active_trans = 1;
-	}
-
-	if (row_search_check_if_query_cache_permitted(trx, norm_name)) {
-
-		/* printf("Query cache for %s permitted\n", norm_name); */
-
-		return((my_bool)TRUE);
-	}
-
-	/* printf("Query cache for %s NOT permitted\n", norm_name); */
-
-	return((my_bool)FALSE);
-}
-
-/*********************************************************************
-Invalidates the MySQL query cache for the table.
-NOTE that the exact prototype of this function has to be in
-/innobase/row/row0ins.c! */
-extern "C" UNIV_INTERN
-void
-innobase_invalidate_query_cache(
-/*============================*/
-	trx_t*,		/* in: transaction which modifies the table */
-	char*,	/* in: concatenation of database name, null
-				char '\0', table name, null char'\0';
-				NOTE that in Windows this is always
-				in LOWER CASE! */
-	ulint)	/* in: full name length where also the null
-				chars count */
-{
-	/* Note that the sync0sync.h rank of the query cache mutex is just
-	above the InnoDB kernel mutex. The caller of this function must not
-	have latches of a lower rank. */
-
-	/* Argument TRUE below means we are using transactions */
-#ifdef HAVE_QUERY_CACHE
-	mysql_query_cache_invalidate4((Session*) trx->mysql_thd,
-				      (const char*) full_name,
-				      (uint32) full_name_len,
-				      TRUE);
-#endif
-}
-
 /*********************************************************************
 Convert an SQL identifier to the MySQL system_charset_info (UTF-8)
 and quote it if needed. */
@@ -2621,12 +2423,7 @@
 handler::Table_flags
 ha_innobase::table_flags() const
 {
-       /* Need to use tx_isolation here since table flags is (also)
-          called before prebuilt is inited. */
-        ulong const tx_isolation = session_tx_isolation(ha_session());
-        if (tx_isolation <= ISO_READ_COMMITTED)
-                return int_table_flags;
-        return int_table_flags | HA_BINLOG_STMT_CAPABLE;
+        return int_table_flags;
 }
 
 /********************************************************************
@@ -2703,13 +2500,6 @@
 }
 
 UNIV_INTERN
-uint8_t
-ha_innobase::table_cache_type()
-{
-	return(HA_CACHE_TBL_ASKTRANSACT);
-}
-
-UNIV_INTERN
 bool
 ha_innobase::primary_key_is_clustered()
 {
@@ -3686,12 +3476,12 @@
 				goto include_field;
 			}
 
-                        if (field->isRead() || field->isWrite())
+                        if (field->isReadSet() || field->isWriteSet())
 				/* This field is needed in the query */
 				goto include_field;
 
-                        assert(table->read_set->test(sql_idx) == field->isRead());
-                        assert(table->write_set->test(sql_idx) == field->isWrite());
+                        assert(table->isReadSet(sql_idx) == field->isReadSet());
+                        assert(table->isWriteSet(sql_idx) == field->isWriteSet());
 
 			if (fetch_primary_key_cols
 				&& dict_table_col_in_clustered_key(
@@ -8514,50 +8304,6 @@
 	return(0);
 }
 
-/***********************************************************************
-Ask InnoDB if a query to a table can be cached. */
-UNIV_INTERN
-my_bool
-ha_innobase::register_query_cache_table(
-/*====================================*/
-					/* out: TRUE if query caching
-					of the table is permitted */
-	Session*		session,		/* in: user thread handle */
-	char*		table_key,	/* in: concatenation of database name,
-					the null character '\0',
-					and the table name */
-	uint		key_length,	/* in: length of the full name, i.e.
-					len(dbname) + len(tablename) + 1 */
-	qc_engine_callback*
-			call_back,	/* out: pointer to function for
-					checking if query caching
-					is permitted */
-	uint64_t	*engine_data)	/* in/out: data to call_back */
-{
-	*call_back = innobase_query_caching_of_table_permitted;
-	*engine_data = 0;
-	return(innobase_query_caching_of_table_permitted(session, table_key,
-							 key_length,
-							 engine_data));
-}
-
-UNIV_INTERN
-char*
-ha_innobase::get_mysql_bin_log_name()
-{
-	return(trx_sys_mysql_bin_log_name);
-}
-
-UNIV_INTERN
-uint64_t
-ha_innobase::get_mysql_bin_log_pos()
-{
-	/* trx... is ib_int64_t, which is a typedef for a 64-bit integer
-	(__int64 or int64_t) so it's ok to cast it to uint64_t. */
-
-	return(trx_sys_mysql_bin_log_pos);
-}
-
 /**********************************************************************
 This function is used to find the storage length in bytes of the first n
 characters for prefix indexes using a multibyte character set. The function
@@ -8796,41 +8542,6 @@
 	}
 }
 
-
-
-UNIV_INTERN
-bool
-ha_innobase::check_if_incompatible_data(
-	HA_CREATE_INFO*	create_info,
-	uint		table_changes)
-{
-	if (table_changes != IS_EQUAL_YES) {
-
-		return(COMPATIBLE_DATA_NO);
-	}
-
-	/* Check that auto_increment value was not changed */
-	if ((create_info->used_fields & HA_CREATE_USED_AUTO) &&
-		create_info->auto_increment_value != 0) {
-
-		return(COMPATIBLE_DATA_NO);
-	}
-
-	/* Check that row format didn't change */
-	if ((create_info->used_fields & HA_CREATE_USED_ROW_FORMAT) &&
-	    get_row_type() != create_info->row_type) {
-
-		return(COMPATIBLE_DATA_NO);
-	}
-
-	/* Specifying KEY_BLOCK_SIZE requests a rebuild of the table. */
-	if (create_info->used_fields & HA_CREATE_USED_KEY_BLOCK_SIZE) {
-		return(COMPATIBLE_DATA_NO);
-	}
-
-	return(COMPATIBLE_DATA_YES);
-}
-
 /****************************************************************
 Validate the file format name and return its corresponding id. */
 static

=== modified file 'plugin/innobase/handler/ha_innodb.h'
--- plugin/innobase/handler/ha_innodb.h	2009-04-28 21:46:57 +0000
+++ plugin/innobase/handler/ha_innodb.h	2009-05-06 05:58:40 +0000
@@ -190,16 +190,6 @@
 
 	virtual bool get_error_message(int error, String *buf);
 
-	uint8_t table_cache_type();
-	/*
-	  ask handler about permission to cache table during query registration
-	*/
-        bool register_query_cache_table(Session *session, char *table_key,
-                                        uint32_t key_length,
-                                        qc_engine_callback *call_back,
-                                        uint64_t *engine_data);
-	static char *get_mysql_bin_log_name();
-	static uint64_t get_mysql_bin_log_pos();
 	bool primary_key_is_clustered();
 	int cmp_ref(const unsigned char *ref1, const unsigned char *ref2);
 	/** Fast index creation (smart ALTER TABLE) @see handler0alter.cc @{ */
@@ -208,9 +198,6 @@
 			       uint num_of_keys);
 	int final_drop_index(TABLE *table_arg);
 	/** @} */
-	bool check_if_incompatible_data(HA_CREATE_INFO *info,
-					uint32_t table_changes);
-	bool check_if_supported_virtual_columns(void) { return true; }
 public:
   /**
    * Multi Range Read interface

=== modified file 'plugin/innobase/row/row0ins.c'
--- plugin/innobase/row/row0ins.c	2009-03-12 22:30:11 +0000
+++ plugin/innobase/row/row0ins.c	2009-05-06 06:19:18 +0000
@@ -50,23 +50,6 @@
 #define	ROW_INS_NEXT	2
 
 
-/*********************************************************************
-This prototype is copied from /mysql/sql/ha_innodb.cc.
-Invalidates the MySQL query cache for the table.
-NOTE that the exact prototype of this function has to be in
-/innobase/row/row0ins.c! */
-extern
-void
-innobase_invalidate_query_cache(
-/*============================*/
-	trx_t*	trx,		/* in: transaction which modifies the table */
-	char*	full_name,	/* in: concatenation of database name, null
-				char '\0', table name, null char'\0';
-				NOTE that in Windows this is always
-				in LOWER CASE! */
-	ulint	full_name_len);	/* in: full name length where also the null
-				chars count */
-
 /*************************************************************************
 Creates an insert node struct. */
 UNIV_INTERN
@@ -752,7 +735,7 @@
 void
 row_ins_invalidate_query_cache(
 /*===========================*/
-	que_thr_t*	thr,		/* in: query thread whose run_node
+	que_thr_t*	unused,		/* in: query thread whose run_node
 					is an update node */
 	const char*	name)		/* in: table name prefixed with
 					database name and a '/' character */
@@ -761,16 +744,14 @@
 	char*	ptr;
 	ulint	len = strlen(name) + 1;
 
+        (void)unused;
+
 	buf = mem_strdupl(name, len);
 
 	ptr = strchr(buf, '/');
 	ut_a(ptr);
 	*ptr = '\0';
 
-	/* We call a function in ha_innodb.cc */
-#ifndef UNIV_HOTBACKUP
-	innobase_invalidate_query_cache(thr_get_trx(thr), buf, len);
-#endif
 	mem_free(buf);
 }
 

=== modified file 'plugin/myisam/ha_myisam.cc'
--- plugin/myisam/ha_myisam.cc	2009-04-29 07:16:04 +0000
+++ plugin/myisam/ha_myisam.cc	2009-05-06 05:44:32 +0000
@@ -486,8 +486,6 @@
 ha_myisam::ha_myisam(StorageEngine *engine_arg, TableShare *table_arg)
   :handler(engine_arg, table_arg), file(0),
   int_table_flags(HA_NULL_IN_KEY |
-                  HA_BINLOG_ROW_CAPABLE |
-                  HA_BINLOG_STMT_CAPABLE |
                   HA_DUPLICATE_POS |
                   HA_CAN_INDEX_BLOBS |
                   HA_AUTO_PART_KEY |
@@ -1780,28 +1778,6 @@
   return (uint)file->state->checksum;
 }
 
-
-bool ha_myisam::check_if_incompatible_data(HA_CREATE_INFO *create_info,
-					   uint32_t table_changes)
-{
-  uint32_t options= table->s->db_options_in_use;
-
-  if (create_info->auto_increment_value != stats.auto_increment_value ||
-      create_info->data_file_name != data_file_name ||
-      create_info->index_file_name != index_file_name ||
-      table_changes == IS_EQUAL_NO ||
-      table_changes & IS_EQUAL_PACK_LENGTH) // Not implemented yet
-    return COMPATIBLE_DATA_NO;
-
-  if ((options & (HA_OPTION_PACK_RECORD | HA_OPTION_CHECKSUM |
-		  HA_OPTION_DELAY_KEY_WRITE)) !=
-      (create_info->table_options & (HA_OPTION_PACK_RECORD |
-                                     HA_OPTION_CHECKSUM |
-			      HA_OPTION_DELAY_KEY_WRITE)))
-    return COMPATIBLE_DATA_NO;
-  return COMPATIBLE_DATA_YES;
-}
-
 static MyisamEngine *engine= NULL;
 
 static int myisam_init(PluginRegistry &registry)

=== modified file 'plugin/myisam/ha_myisam.h'
--- plugin/myisam/ha_myisam.h	2009-04-29 07:16:04 +0000
+++ plugin/myisam/ha_myisam.h	2009-05-06 05:44:32 +0000
@@ -118,14 +118,6 @@
   bool auto_repair() const { return myisam_recover_options != 0; }
   int optimize(Session* session, HA_CHECK_OPT* check_opt);
   int assign_to_keycache(Session* session, HA_CHECK_OPT* check_opt);
-  bool check_if_incompatible_data(HA_CREATE_INFO *info, uint32_t table_changes);
-#ifdef HAVE_QUERY_CACHE
-  bool register_query_cache_table(Session *session, char *table_key,
-                                     uint32_t key_length,
-                                     qc_engine_callback
-                                     *engine_callback,
-                                     uint64_t *engine_data);
-#endif
   MI_INFO *file_ptr(void)
   {
     return file;
@@ -149,7 +141,6 @@
 
   /* Index condition pushdown implementation */
   Item *idx_cond_push(uint32_t keyno, Item* idx_cond);
-  bool check_if_supported_virtual_columns(void) { return true; }
 private:
   DsMrr_impl ds_mrr;
   key_map keys_with_parts;

=== modified file 'tests/r/innodb.result'
--- tests/r/innodb.result	2009-03-11 01:16:44 +0000
+++ tests/r/innodb.result	2009-05-06 03:58:07 +0000
@@ -2051,8 +2051,6 @@
 alter table t1 modify v varchar(300), drop key v, drop key v_2, add key v (v);
 Warnings:
 Warning	1071	Specified key was too long; max key length is 767 bytes
-Warning	1071	Specified key was too long; max key length is 767 bytes
-Warning	1071	Specified key was too long; max key length is 767 bytes
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
@@ -2215,8 +2213,6 @@
 alter table t1 modify v varchar(600), drop key v, add key v (v);
 Warnings:
 Warning	1071	Specified key was too long; max key length is 767 bytes
-Warning	1071	Specified key was too long; max key length is 767 bytes
-Warning	1071	Specified key was too long; max key length is 767 bytes
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (

=== modified file 'tests/r/innodb_mysql.result'
--- tests/r/innodb_mysql.result	2009-03-11 09:51:44 +0000
+++ tests/r/innodb_mysql.result	2009-05-06 03:58:07 +0000
@@ -992,8 +992,6 @@
 alter table t1 add index(a(1024));
 Warnings:
 Warning	1071	Specified key was too long; max key length is 767 bytes
-Warning	1071	Specified key was too long; max key length is 767 bytes
-Warning	1071	Specified key was too long; max key length is 767 bytes
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (

=== modified file 'tests/r/mix2_myisam.result'
--- tests/r/mix2_myisam.result	2009-02-28 20:43:31 +0000
+++ tests/r/mix2_myisam.result	2009-05-06 03:58:07 +0000
@@ -1841,8 +1841,6 @@
 alter table t1 modify v varchar(600), drop key v, add key v (v);
 Warnings:
 Warning	1071	Specified key was too long; max key length is 1332 bytes
-Warning	1071	Specified key was too long; max key length is 1332 bytes
-Warning	1071	Specified key was too long; max key length is 1332 bytes
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (

=== modified file 'tests/r/myisam.result'
--- tests/r/myisam.result	2009-02-21 16:00:06 +0000
+++ tests/r/myisam.result	2009-05-06 03:58:07 +0000
@@ -1375,8 +1375,6 @@
 alter table t1 modify v varchar(600), drop key v, add key v (v);
 Warnings:
 Warning	1071	Specified key was too long; max key length is 1332 bytes
-Warning	1071	Specified key was too long; max key length is 1332 bytes
-Warning	1071	Specified key was too long; max key length is 1332 bytes
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (

=== modified file 'tests/r/union.result'
--- tests/r/union.result	2009-03-25 09:18:25 +0000
+++ tests/r/union.result	2009-05-06 03:58:07 +0000
@@ -1209,7 +1209,6 @@
 alter table t2 ROW_FORMAT=fixed;
 Warnings:
 Warning	1478	InnoDB: assuming ROW_FORMAT=COMPACT.
-Warning	1478	InnoDB: assuming ROW_FORMAT=COMPACT.
 show create table t2;
 Table	Create Table
 t2	CREATE TABLE `t2` (

